# -*- coding: utf-8 -*-

"""
    my_countries_api_1234567

    This file was automatically generated by APIMATIC v2.0 ( https://apimatic.io ).
"""

import jsonpickle
import dateutil.parser
from .controller_test_base import ControllerTestBase
from ..test_helper import TestHelper
from my_countries_api_1234567.api_helper import APIHelper


class CountriesControllerTests(ControllerTestBase):

    @classmethod
    def setUpClass(cls):
        super(CountriesControllerTests, cls).setUpClass()
        cls.controller = cls.api_client.countries

    # Test case for countries API
    def test_countries_api(self):

        # Perform the API call through the SDK function
        result = self.controller.get_countries()

        # Test response code
        self.assertEquals(self.response_catcher.response.status_code, 200)
        
        # Test whether the captured response is as we expected
        self.assertIsNotNone(result)
        expected_body = APIHelper.json_deserialize(
            '{"http_code":200,"response_code":"SUCCESS","response_msg":"List of Countri'
            'es.","data":[{"code":"PK","value":"Pakistan"},{"code":"AF","value":"Afghani'
            'stan"},{"code":"AX","value":"Aland Islands"},{"code":"AL","value":"Albania"'
            '},{"code":"DZ","value":"Algeria"},{"code":"AS","value":"American Samoa"},{"'
            'code":"AD","value":"Andorra"},{"code":"AO","value":"Angola"},{"code":"AI","'
            'value":"Anguilla"},{"code":"AQ","value":"Antarctica"},{"code":"AG","value":'
            '"Antigua and Barbuda"},{"code":"AR","value":"Argentina"},{"code":"AM","valu'
            'e":"Armenia"},{"code":"AW","value":"Aruba"},{"code":"AU","value":"Australia'
            '"},{"code":"AT","value":"Austria"},{"code":"AZ","value":"Azerbaijan"},{"cod'
            'e":"BS","value":"Bahamas"},{"code":"BH","value":"Bahrain"},{"code":"BD","va'
            'lue":"Bangladesh"},{"code":"BB","value":"Barbados"},{"code":"BY","value":"B'
            'elarus"},{"code":"BE","value":"Belgium"},{"code":"BZ","value":"Belize"},{"c'
            'ode":"BJ","value":"Benin"},{"code":"BM","value":"Bermuda"},{"code":"BT","va'
            'lue":"Bhutan"},{"code":"BO","value":"Bolivia"},{"code":"BA","value":"Bosnia'
            ' and Herzegovina"},{"code":"BW","value":"Botswana"},{"code":"BV","value":"B'
            'ouvet Island"},{"code":"BR","value":"Brazil"},{"code":"IO","value":"British'
            ' Indian Ocean Territory"},{"code":"BN","value":"Brunei"},{"code":"BG","valu'
            'e":"Bulgaria"},{"code":"BF","value":"Burkina Faso"},{"code":"BI","value":"B'
            'urundi"},{"code":"KH","value":"Cambodia"},{"code":"CM","value":"Cameroon"},'
            '{"code":"CA","value":"Canada"},{"code":"CV","value":"Cape Verde"},{"code":"'
            'KY","value":"Cayman Islands"},{"code":"CF","value":"Central African Republi'
            'c"},{"code":"TD","value":"Chad"},{"code":"CL","value":"Chile"},{"code":"CN"'
            ',"value":"China"},{"code":"CX","value":"Christmas Island"},{"code":"CC","va'
            'lue":"Cocos (Keeling) Islands"},{"code":"CO","value":"Colombia"},{"code":"K'
            'M","value":"Comoros"},{"code":"CG","value":"Congo"},{"code":"CD","value":"C'
            'ongo, Democratic Republic"},{"code":"CK","value":"Cook Islands"},{"code":"C'
            'R","value":"Costa Rica"},{"code":"CI","value":"Cote D\'Ivoire"},{"code":"HR'
            '","value":"Croatia"},{"code":"CU","value":"Cuba"},{"code":"CY","value":"Cyp'
            'rus"},{"code":"CZ","value":"Czech Republic"},{"code":"DK","value":"Denmark"'
            '},{"code":"DJ","value":"Djibouti"},{"code":"DM","value":"Dominica"},{"code"'
            ':"DO","value":"Dominican Republic"},{"code":"EC","value":"Ecuador"},{"code"'
            ':"EG","value":"Egypt"},{"code":"SV","value":"El Salvador"},{"code":"GQ","va'
            'lue":"Equatorial Guinea"},{"code":"ER","value":"Eritrea"},{"code":"EE","val'
            'ue":"Estonia"},{"code":"ET","value":"Ethiopia"},{"code":"FK","value":"Falkl'
            'and Islands (Malvinas)"},{"code":"FO","value":"Faroe Islands"},{"code":"FJ"'
            ',"value":"Fiji"},{"code":"FI","value":"Finland"},{"code":"FR","value":"Fran'
            'ce"},{"code":"GF","value":"French Guiana"},{"code":"PF","value":"French Pol'
            'ynesia"},{"code":"TF","value":"French Southern Territories"},{"code":"GA","'
            'value":"Gabon"},{"code":"GM","value":"Gambia"},{"code":"GE","value":"Georgi'
            'a"},{"code":"DE","value":"Germany"},{"code":"GH","value":"Ghana"},{"code":"'
            'GI","value":"Gibraltar"},{"code":"GR","value":"Greece"},{"code":"GL","value'
            '":"Greenland"},{"code":"GD","value":"Grenada"},{"code":"GP","value":"Guadel'
            'oupe"},{"code":"GU","value":"Guam"},{"code":"GT","value":"Guatemala"},{"cod'
            'e":"GG","value":"Guernsey"},{"code":"GN","value":"Guinea"},{"code":"GW","va'
            'lue":"Guinea-Bissau"},{"code":"GY","value":"Guyana"},{"code":"HT","value":"'
            'Haiti"},{"code":"HM","value":"Heard Island & Mcdonald Islands"},{"code":"VA'
            '","value":"Holy See (Vatican City State)"},{"code":"HN","value":"Honduras"}'
            ',{"code":"HK","value":"Hong Kong"},{"code":"HU","value":"Hungary"},{"code":'
            '"IS","value":"Iceland"},{"code":"IN","value":"India"},{"code":"ID","value":'
            '"Indonesia"},{"code":"IR","value":"Iran"},{"code":"IQ","value":"Iraq"},{"co'
            'de":"IE","value":"Ireland"},{"code":"IM","value":"Isle of Man"},{"code":"IL'
            '","value":"Israel"},{"code":"IT","value":"Italy"},{"code":"JM","value":"Jam'
            'aica"},{"code":"JP","value":"Japan"},{"code":"JE","value":"Jersey"},{"code"'
            ':"JO","value":"Jordan"},{"code":"KZ","value":"Kazakhstan"},{"code":"KE","va'
            'lue":"Kenya"},{"code":"KI","value":"Kiribati"},{"code":"KP","value":"North '
            'Korea"},{"code":"KR","value":"South Korea"},{"code":"KW","value":"Kuwait"},'
            '{"code":"XK","value":"Kosovo"},{"code":"KG","value":"Kyrgyzstan"},{"code":"'
            'LA","value":"Laos"},{"code":"LV","value":"Latvia"},{"code":"LB","value":"Le'
            'banon"},{"code":"LS","value":"Lesotho"},{"code":"LR","value":"Liberia"},{"c'
            'ode":"LY","value":"Libya"},{"code":"LI","value":"Liechtenstein"},{"code":"L'
            'T","value":"Lithuania"},{"code":"LU","value":"Luxembourg"},{"code":"MO","va'
            'lue":"Macao"},{"code":"MK","value":"Macedonia"},{"code":"MG","value":"Madag'
            'ascar"},{"code":"MW","value":"Malawi"},{"code":"MY","value":"Malaysia"},{"c'
            'ode":"MV","value":"Maldives"},{"code":"ML","value":"Mali"},{"code":"MT","va'
            'lue":"Malta"},{"code":"MH","value":"Marshall Islands"},{"code":"MQ","value"'
            ':"Martinique"},{"code":"MR","value":"Mauritania"},{"code":"MU","value":"Mau'
            'ritius"},{"code":"YT","value":"Mayotte"},{"code":"MX","value":"Mexico"},{"c'
            'ode":"FM","value":"Micronesia"},{"code":"MD","value":"Moldova"},{"code":"MC'
            '","value":"Monaco"},{"code":"MN","value":"Mongolia"},{"code":"ME","value":"'
            'Montenegro"},{"code":"MS","value":"Montserrat"},{"code":"MA","value":"Moroc'
            'co"},{"code":"MZ","value":"Mozambique"},{"code":"MM","value":"Myanmar (Burm'
            'a)"},{"code":"NA","value":"Namibia"},{"code":"NR","value":"Nauru"},{"code":'
            '"NP","value":"Nepal"},{"code":"NL","value":"Netherlands"},{"code":"AN","val'
            'ue":"Netherlands Antilles"},{"code":"NC","value":"New Caledonia"},{"code":"'
            'NZ","value":"New Zealand"},{"code":"NI","value":"Nicaragua"},{"code":"NE","'
            'value":"Niger"},{"code":"NG","value":"Nigeria"},{"code":"NU","value":"Niue"'
            '},{"code":"NF","value":"Norfolk Island"},{"code":"MP","value":"Northern Mar'
            'iana Islands"},{"code":"NO","value":"Norway"},{"code":"OM","value":"Oman"},'
            '{"code":"PW","value":"Palau"},{"code":"PS","value":"Palestinian Territories'
            '"},{"code":"PA","value":"Panama"},{"code":"PG","value":"Papua New Guinea"},'
            '{"code":"PY","value":"Paraguay"},{"code":"PE","value":"Peru"},{"code":"PH",'
            '"value":"Philippines"},{"code":"PN","value":"Pitcairn"},{"code":"PL","value'
            '":"Poland"},{"code":"PT","value":"Portugal"},{"code":"PR","value":"Puerto R'
            'ico"},{"code":"QA","value":"Qatar"},{"code":"RE","value":"Reunion"},{"code"'
            ':"RO","value":"Romania"},{"code":"RU","value":"Russia"},{"code":"RW","value'
            '":"Rwanda"},{"code":"BL","value":"Saint Barthelemy"},{"code":"SH","value":"'
            'Saint Helena"},{"code":"KN","value":"Saint Kitts and Nevis"},{"code":"LC","'
            'value":"Saint Lucia"},{"code":"MF","value":"Saint Martin"},{"code":"PM","va'
            'lue":"Saint Pierre and Miquelon"},{"code":"VC","value":"Saint Vincent and t'
            'he Grenadines"},{"code":"WS","value":"Samoa"},{"code":"SM","value":"San Mar'
            'ino"},{"code":"ST","value":"Sao Tome And Principe"},{"code":"SA","value":"S'
            'audi Arabia"},{"code":"SN","value":"Senegal"},{"code":"RS","value":"Serbia"'
            '},{"code":"SC","value":"Seychelles"},{"code":"SL","value":"Sierra Leone"},{'
            '"code":"SG","value":"Singapore"},{"code":"SK","value":"Slovakia"},{"code":"'
            'SI","value":"Slovenia"},{"code":"SB","value":"Solomon Islands"},{"code":"SO'
            '","value":"Somalia"},{"code":"ZA","value":"South Africa"},{"code":"GS","val'
            'ue":"South Georgia And Sandwich Isl."},{"code":"ES","value":"Spain"},{"code'
            '":"LK","value":"Sri Lanka"},{"code":"SD","value":"Sudan"},{"code":"SR","val'
            'ue":"Suriname"},{"code":"SJ","value":"Svalbard and Jan Mayen"},{"code":"SZ"'
            ',"value":"Swaziland"},{"code":"SE","value":"Sweden"},{"code":"CH","value":"'
            'Switzerland"},{"code":"SY","value":"Syria"},{"code":"TW","value":"Taiwan"},'
            '{"code":"TJ","value":"Tajikistan"},{"code":"TZ","value":"Tanzania"},{"code"'
            ':"TH","value":"Thailand"},{"code":"TL","value":"Timor-Leste"},{"code":"TG",'
            '"value":"Togo"},{"code":"TK","value":"Tokelau"},{"code":"TO","value":"Tonga'
            '"},{"code":"TT","value":"Trinidad and Tobago"},{"code":"TN","value":"Tunisi'
            'a"},{"code":"TR","value":"Turkey"},{"code":"TM","value":"Turkmenistan"},{"c'
            'ode":"TC","value":"Turks and Caicos Islands"},{"code":"TV","value":"Tuvalu"'
            '},{"code":"UG","value":"Uganda"},{"code":"UA","value":"Ukraine"},{"code":"A'
            'E","value":"United Arab Emirates"},{"code":"GB","value":"United Kingdom"},{'
            '"code":"UM","value":"United States Outlying Islands"},{"code":"US","value":'
            '"United States of America"},{"code":"UY","value":"Uruguay"},{"code":"UZ","v'
            'alue":"Uzbekistan"},{"code":"VU","value":"Vanuatu"},{"code":"VE","value":"V'
            'enezuela"},{"code":"VN","value":"Vietnam"},{"code":"VG","value":"British Vi'
            'rgin Islands"},{"code":"VI","value":"U.S. Virgin Islands"},{"code":"WF","va'
            'lue":"Wallis and Futuna"},{"code":"EH","value":"Western Sahara"},{"code":"Y'
            'E","value":"Yemen"},{"code":"ZM","value":"Zambia"},{"code":"ZW","value":"Zi'
            'mbabwe"}]}'
            )
        received_body = APIHelper.json_deserialize(self.response_catcher.response.raw_body)
        self.assertTrue(TestHelper.match_body(expected_body, received_body))


